package cn.javacoder.cas_client_proxy;

import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URLEncoder;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClientBuilder;
import org.jasig.cas.client.authentication.AttributePrincipal;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;

import com.fasterxml.jackson.databind.ObjectMapper;

@Controller
public class TestController {

	@RequestMapping("test.do")
	@SuppressWarnings("rawtypes")
	public static  String test(Model model, HttpServletRequest request) throws Exception {
		HttpClientBuilder builder = HttpClientBuilder.create();
		CloseableHttpClient client = builder.build();
		
		AttributePrincipal principal = (AttributePrincipal)request.getUserPrincipal();
		String targetUrl = "http://app1.javacoder.cn:9080/cas-client/hello.do";
		String proxyTicket = principal.getProxyTicketFor(targetUrl);
		String serviceUrl = targetUrl+"?ticket="+URLEncoder.encode(proxyTicket, "UTF-8");
		
		HttpUriRequest uriRequest = new HttpGet(serviceUrl);
		HttpResponse response = client.execute(uriRequest );
		HttpEntity entity = response.getEntity();
		InputStream inputStream = entity.getContent();
		InputStreamReader reader = new InputStreamReader(inputStream , "UTF-8");
		
		StringBuilder stringBuilder = new StringBuilder();
		char[] cbuf = new char[1024];
		int sz = 0;
		while((sz = reader.read(cbuf)) != -1) {
			stringBuilder.append(cbuf, 0, sz);
		}
		
		ObjectMapper mapper = new ObjectMapper();  
		Map user = mapper.readValue(stringBuilder.toString(), Map.class);
		model.addAttribute("user", user);
		
		reader.close();
		client.close();
		return "index";
	}

	public static void main(String[] args) {
		String s = "";
		System.out.println(s);
	}

}
