package cn.javacoder.test_sso.filter;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class AccessFilter implements Filter {

	public void destroy() {

	}

	public void doFilter(ServletRequest arg0, ServletResponse arg1, FilterChain chain) throws IOException,
			ServletException {
		String loginUrl = "/test-sso/login.do";
		String authUrl = "/test-sso/authenticate.do";
		HttpServletRequest request = (HttpServletRequest) arg0;
		HttpServletResponse response = (HttpServletResponse) arg1;
		String requestURL = request.getRequestURI();
		
		if (isStaticFile(requestURL)) {
			chain.doFilter(arg0, arg1);
		} else if (loginUrl.equals(requestURL) || authUrl.equals(requestURL)) {
			chain.doFilter(arg0, arg1);
		} else if(request.getSession().getAttribute("user") != null) {
			chain.doFilter(arg0, arg1);
		} else {
			response.sendRedirect(loginUrl);
		}
	}

	public void init(FilterConfig arg0) throws ServletException {

	}

	private boolean isStaticFile(String requestURL) {
		// 如果是静态文件，*.png, *.css, *.js, 让其直接通过
		boolean isStaticFile = false;
		String ignoreSuffixArr[] = { ".png", ".css", ".js" };
		for (String suffix : ignoreSuffixArr) {
			if (requestURL.endsWith(suffix)) {
				isStaticFile = true;
				break;
			}
		}
		return isStaticFile;
	}

	

}
