package cn.javacoder.test_sso.filter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletRequestWrapper;
import javax.servlet.http.HttpSession;

public class MemcacheHttpServletRequest extends HttpServletRequestWrapper {
	private String sessionKey;
	
	public MemcacheHttpServletRequest(HttpServletRequest request, String sessionKey) {
		super(request);
		this.sessionKey = sessionKey;
	}

	public String getSessionKey() {
		return sessionKey;
	}

	public void setSessionKey(String sessionKey) {
		this.sessionKey = sessionKey;
	}

	@Override
	public HttpSession getSession() {
		if(sessionKey == null) {
			throw new RuntimeException("sessionKey is null");
		}
		return new MemcachedSession(sessionKey);
	}

	@Override
	public HttpSession getSession(boolean create) {
		return this.getSession();
	}

	
}
