package cn.javacoder.test_sso.filter;

import java.net.InetSocketAddress;
import java.util.UUID;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import cn.javacoder.test_sso.vo.UserInfo;
import net.spy.memcached.MemcachedClient;

public class MemcachedSessionUtil {

	private static MemcachedClient instance;

	public static MemcachedClient getInstance() {
		try {
			if (instance != null) {
				return instance;
			} else {
				instance = new MemcachedClient(new InetSocketAddress("192.168.6.131", 11211));
				return instance;
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public static boolean authWithMemcached(HttpServletRequest request) {
		boolean authPass = false;
		try {
			String sessionKey = getSessionKey(request, null);
			if (sessionKey != null) {
				UserInfo userInfo = (UserInfo) getInstance().get(sessionKey);
				authPass = userInfo != null;
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
		return authPass;
	}
	
	public static String getSessionKey(HttpServletRequest request, HttpServletResponse response) {
		Cookie[] cookies = request.getCookies();
		String sessionKey = null;
		
		if(cookies != null) {
			for (Cookie cookie : cookies) {
				if ("test_sso_session_key".equals(cookie.getName())) {
					sessionKey = cookie.getValue();
					break;
				}
			}
		}
		
		if (sessionKey == null && response != null) {
			sessionKey = UUID.randomUUID().toString();
			sessionKey = sessionKey.replace("-", "");
			Cookie cookie = new Cookie("test_sso_session_key", sessionKey);
			cookie.setMaxAge(30 * 60);
			cookie.setDomain("javacoder.cn");
			cookie.setPath("/");
			response.addCookie(cookie);
		}
		return sessionKey;
	}
	
	public static boolean setSession(HttpServletRequest request, HttpServletResponse response, UserInfo userInfo) {
		boolean authPass = false;
		try {
			getInstance().set(getSessionKey(request, response), 30*60, userInfo);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		return authPass;
	}
	
	public static boolean removeSession(HttpServletRequest request,HttpServletResponse response) {
		try {
			getInstance().delete(getSessionKey(request, response));
		} catch (Exception e) {
			e.printStackTrace();
		}
		return true;
	}
}
